  function B = JPEG(A)
% A is an mxn picture matrix and B is its mxn JPEG-compressed analog.

% A is an m1-by-n1 block matrix with 8x8 blocks...
[m,n] = size(A);
m1 = m/8;
n1 = n/8;
% Obtain the 8x8 quantization matrix...
Q = Quant();
% Regard A as an (m/8)-by-n block matrix whose blocks are column 8-vectors.
% Assemble these vectors into an 8-by-mn/8) array..
B = reshape(A,8,m*n/8);
% Compute the DCT of these vectors...
B = DCT8(B);
% Here is A with each of its length-8 subcolumns updated by the DCT..
B = reshape(B,m,n);
% The rows of this matrix are now columns of...
B = B';
% Regard this matrix as an 8-by-mn/8 block matrix whose blocks are column
% 8-vectors...
B = reshape(B,8,m*n/8);
% Compute the DCT of these vectors...
B = DCT8(B);
% Here is A' with each of its 8x8 blocks DCT'd...
B = reshape(B,n,m);
% Here is A with each of its 8x8 blocks DCT's
B = B';
% Apply Q to each of these blocks and round...
B = round(B./kron(ones(m1,n1),Q));

